// Dark color mode variables
//
// Custom variables for the `[data-bs-theme="dark"]` theme. Use this as a starting point for your own custom color modes by creating a new theme-specific file like `_variables-dark.scss` and adding the variables you need.

//
// Global colors
//

// scss-docs-start sass-dark-mode-vars
// scss-docs-start theme-text-dark-variables
$primary-text-emphasis-dark: tint-color($primary, 40%) !default;
$secondary-text-emphasis-dark: tint-color($secondary, 40%) !default;
$success-text-emphasis-dark: tint-color($success, 40%) !default;
$info-text-emphasis-dark: tint-color($info, 40%) !default;
$warning-text-emphasis-dark: tint-color($warning, 40%) !default;
$danger-text-emphasis-dark: tint-color($danger, 40%) !default;
$light-text-emphasis-dark: $gray-100 !default;
$dark-text-emphasis-dark: $gray-300 !default;
// scss-docs-end theme-text-dark-variables

// scss-docs-start theme-bg-subtle-dark-variables
$primary-bg-subtle-dark: shade-color($primary, 80%) !default;
$secondary-bg-subtle-dark: shade-color($secondary, 80%) !default;
$success-bg-subtle-dark: shade-color($success, 80%) !default;
$info-bg-subtle-dark: shade-color($info, 80%) !default;
$warning-bg-subtle-dark: shade-color($warning, 80%) !default;
$danger-bg-subtle-dark: shade-color($danger, 80%) !default;
$light-bg-subtle-dark: $gray-800 !default;
$dark-bg-subtle-dark: mix($gray-800, $black) !default;
// scss-docs-end theme-bg-subtle-dark-variables

// scss-docs-start theme-border-subtle-dark-variables
$primary-border-subtle-dark: shade-color($primary, 40%) !default;
$secondary-border-subtle-dark: shade-color($secondary, 40%) !default;
$success-border-subtle-dark: shade-color($success, 40%) !default;
$info-border-subtle-dark: shade-color($info, 40%) !default;
$warning-border-subtle-dark: shade-color($warning, 40%) !default;
$danger-border-subtle-dark: shade-color($danger, 40%) !default;
$light-border-subtle-dark: $gray-700 !default;
$dark-border-subtle-dark: $gray-800 !default;
// scss-docs-end theme-border-subtle-dark-variables

$body-color-dark: $gray-300 !default;
$body-bg-dark: $gray-900 !default;
$body-secondary-color-dark: rgba($body-color-dark, 0.75) !default;
$body-secondary-bg-dark: $gray-800 !default;
$body-tertiary-color-dark: rgba($body-color-dark, 0.5) !default;
$body-tertiary-bg-dark: mix($gray-800, $gray-900, 50%) !default;
$body-emphasis-color-dark: $white !default;
$border-color-dark: $gray-700 !default;
$border-color-translucent-dark: rgba($white, 0.15) !default;
$headings-color-dark: inherit !default;
$link-color-dark: tint-color($primary, 40%) !default;
$link-hover-color-dark: shift-color($link-color-dark, -$link-shade-percentage) !default;
$code-color-dark: tint-color($code-color, 40%) !default;
$mark-color-dark: $body-color-dark !default;
$mark-bg-dark: $yellow-800 !default;

//
// Forms
//

$form-select-indicator-color-dark: $body-color-dark !default;
$form-select-indicator-dark: url("data:image/svg+xml,<svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16'><path fill='none' stroke='#{$form-select-indicator-color-dark}' stroke-linecap='round' stroke-linejoin='round' stroke-width='2' d='m2 5 6 6 6-6'/></svg>") !default;

$form-switch-color-dark: rgba($white, 0.25) !default;
$form-switch-bg-image-dark: url("data:image/svg+xml,<svg xmlns='http://www.w3.org/2000/svg' viewBox='-4 -4 8 8'><circle r='3' fill='#{$form-switch-color-dark}'/></svg>") !default;

// scss-docs-start form-validation-colors-dark
$form-valid-color-dark: $green-300 !default;
$form-valid-border-color-dark: $green-300 !default;
$form-invalid-color-dark: $red-300 !default;
$form-invalid-border-color-dark: $red-300 !default;
// scss-docs-end form-validation-colors-dark

//
// Accordion
//

$accordion-icon-color-dark: $primary-text-emphasis-dark !default;
$accordion-icon-active-color-dark: $primary-text-emphasis-dark !default;

$accordion-button-icon-dark: url("data:image/svg+xml,<svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16' fill='#{$accordion-icon-color-dark}'><path fill-rule='evenodd' d='M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z'/></svg>") !default;
$accordion-button-active-icon-dark: url("data:image/svg+xml,<svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16' fill='#{$accordion-icon-active-color-dark}'><path fill-rule='evenodd' d='M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z'/></svg>") !default;
// scss-docs-end sass-dark-mode-vars

$light-to-dark: (
  "100": "900",
  "200": "800",
  "300": "700",
  "400": "600",
  "500": "500",
  "600": "400",
  "700": "300",
  "800": "200",
  "900": "100",
);

@function to-dark-variable($color) {
  // @return --#{$prefix}-#{$color}-#{$value};

  $_map: ();

  @each $key, $value in $light-to-dark {
    // allow to pass the $key and $value of the map as an function argument
    $_args: ();

    $_map: map-merge($_map, (#{$color}-#{$key}: map-get($theme-colors-rgb, #{$color}-#{$value})));
  }

  @return $_map;
}

$theme-colors-dark: (
  "primary": to-rgb($primary),
  "secondary": to-rgb($secondary),
  "success": to-rgb($success),
  "info": to-rgb($info),
  "warning": to-rgb($warning),
  "danger": to-rgb($danger),
  "light": to-rgb($gray-900),
  "dark": to-rgb($gray-100),
);

$theme-colors-dark: map-merge(
  $theme-colors-dark,
  (
    "black": to-rgb($white),
    "white": to-rgb($black),
    "blue": to-rgb($blue),
    "indigo": to-rgb($indigo),
    "purple": to-rgb($purple),
    "pink": to-rgb($pink),
    "red": to-rgb($red),
    "orange": to-rgb($orange),
    "yellow": to-rgb($yellow),
    "green": to-rgb($green),
    "teal": to-rgb($teal),
    "cyan": to-rgb($cyan),
    "gray": to-rgb($gray-500),
  )
);

$theme-colors-dark: map-merge($theme-colors-dark, (to-dark-variable("blue")));
$theme-colors-dark: map-merge($theme-colors-dark, (to-dark-variable("indigo")));
$theme-colors-dark: map-merge($theme-colors-dark, (to-dark-variable("purple")));
$theme-colors-dark: map-merge($theme-colors-dark, (to-dark-variable("pink")));
$theme-colors-dark: map-merge($theme-colors-dark, (to-dark-variable("red")));
$theme-colors-dark: map-merge($theme-colors-dark, (to-dark-variable("orange")));
$theme-colors-dark: map-merge($theme-colors-dark, (to-dark-variable("yellow")));
$theme-colors-dark: map-merge($theme-colors-dark, (to-dark-variable("green")));
$theme-colors-dark: map-merge($theme-colors-dark, (to-dark-variable("teal")));
$theme-colors-dark: map-merge($theme-colors-dark, (to-dark-variable("cyan")));
$theme-colors-dark: map-merge($theme-colors-dark, (to-dark-variable("gray")));

[data-bs-theme="dark"] {
  @each $name, $value in $theme-colors-dark {
    --bs-#{$name}: rgb(#{$value});
    --bs-#{$name}-rgb: #{$value};
    --bs-#{$name}-rgba: #{$value}, 1;
  }
}
